package com.obm.jniarr;

import android.content.Intent;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.support.v7.app.AppCompatActivity;
import android.text.TextUtils;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.WindowManager;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;

import com.google.zxing.WriterException;
import com.obm.mylibrary.PicFromPrintUtils;
import com.obm.mylibrary.PrintConnect;
import com.obm.mylibrary.PrintUnits;
import com.obm.mylibrary.ScanConnect;

import java.io.IOException;
import java.io.UnsupportedEncodingException;

public class MainActivity extends AppCompatActivity {

    private ScanConnect mScanConnect;
    public static PrintConnect mPrintConnect;
    private String data="";
    private int con = 0, speed = 7, width = 1, height = 1,count=0;
    private EditText text;
    private SeekBar sb_con, sb_speed, sb_width, sb_height;
    private TextView tv_count,tv_con,tv_speed,tv_width,tv_height;
    private ImageView code_img;
    private Bitmap bitmap = null;
    private Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            super.handleMessage(msg);
            switch (msg.what) {
                case 11:
                    String str=msg.obj.toString();
                    if (data.equals(str)){
                        count++;
                    }else{
                        count=1;
                    }
                    data=str;
                    text.setText(str);
                    tv_count.setText(count+"");
                    break;
            }
        }
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_ADJUST_PAN);
        initView();
        setListener();
        mScanConnect = new ScanConnect(this, mHandler);
        mPrintConnect = new PrintConnect(this);
        sb_height.setProgress(39);
    }

    @Override
    public boolean onCreateOptionsMenu(final Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.context_menu:
                Intent intent=new Intent(this,TextActivity.class);
                startActivity(intent);
                break;
        }
        return super.onOptionsItemSelected(item);
    }


    private void initView() {
        text = (EditText) findViewById(R.id.text);
        sb_con = (SeekBar) findViewById(R.id.sb_con);
        sb_speed = (SeekBar) findViewById(R.id.sb_speed);
        sb_width = (SeekBar) findViewById(R.id.sb_width);
        sb_height = (SeekBar) findViewById(R.id.sb_height);
        code_img = (ImageView) findViewById(R.id.code_img);

        tv_count = (TextView) findViewById(R.id.tv_count);
        tv_con = (TextView) findViewById(R.id.tv_con);
        tv_speed = (TextView) findViewById(R.id.tv_speed);
        tv_width = (TextView) findViewById(R.id.tv_width);
        tv_height = (TextView) findViewById(R.id.tv_height);
    }

    private void setListener() {
        sb_con.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                if (progress == 0) {
                    con = 1;
                } else if (progress == 1) {
                    con = 0;
                } else {
                    con = progress;
                }
                tv_con.setText(con+"");
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });
        sb_speed.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                switch (progress) {
                    case 0:
                        speed = 7;
                        break;
                    case 1:
                        speed = 6;
                        break;
                    case 2:
                        speed = 5;
                        break;
                    case 3:
                        speed = 4;
                        break;
                    case 4:
                        speed = 3;
                        break;
                    case 5:
                        speed = 2;
                        break;
                    case 6:
                        speed = 1;
                        break;
                    case 7:
                        speed = 0;
                        break;
                }
                tv_speed.setText(speed+"");
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });
        sb_height.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                height = progress + 1;
                tv_height.setText(height+"");
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });
        sb_width.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                width = progress + 1;
                tv_width.setText(width+"");
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });
    }

    public void onClick(View v) {
        String data = text.getText().toString();
        if (TextUtils.isEmpty(data)) {
            Toast.makeText(this, R.string.toast_insert_text, Toast.LENGTH_SHORT).show();
            return;
        }
        PrintUnits.setSpeed(mPrintConnect.os, speed);
        PrintUnits.setConcentration(mPrintConnect.os, con);
        switch (v.getId()) {
            case R.id.btn_checktwo:
                createTwoCode(data);
                break;
            case R.id.btn_checkone:
                createOneCode(data);
                break;
            case R.id.btn_printtwo:
                createTwoCode(data);
                if (bitmap != null) {
                    mPrintConnect.send(bitmap);
                    try {
                        mPrintConnect.os.flush();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
                break;
            case R.id.btn_printone:
                createOneCode(data);
                if (bitmap != null) {
                    mPrintConnect.send(bitmap);
                    try {
                        mPrintConnect.os.flush();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
                break;
            case R.id.btn_print:
                int size1 = data.length();
                for (int i = 0; i < size1; i++) {
                    int c = data.charAt(i);
                    if ((19968 <= c && c < 40623)) {
                        Toast.makeText(MainActivity.this, R.string.toast_no_chinese, Toast.LENGTH_SHORT).show();
                        return;
                    }
                }
                mPrintConnect.sendCode128(data, width, height);
                break;
            case R.id.btn_line:
                StringBuffer sb = new StringBuffer();
                sb.delete(0, sb.length());
                for (int i = 0; i < 32*5; i++) {
                    sb.append("-");
                }
                sb.append("\n");
                mPrintConnect.send(sb.toString());
                break;
        }
    }

    //生成一维码
    private void createOneCode(String data) {
        bitmap = null;
        int size = data.length();
        for (int i = 0; i < size; i++) {
            int c = data.charAt(i);
            if ((19968 <= c && c < 40623)) {
                Toast.makeText(MainActivity.this, getString(R.string.toast_no_chinese), Toast.LENGTH_SHORT).show();
                return;
            }
        }
        Bitmap bmp1 = null;
        try {
            if (!TextUtils.isEmpty(data)) {
                bmp1 = CodeUtils.CreateOneDCode(data);
                bmp1 = PicFromPrintUtils.compressonePic(bmp1);
            }
        } catch (WriterException e) {
            e.printStackTrace();
        }
        if (bmp1 != null) {
            code_img.setImageBitmap(bmp1);
            bitmap = bmp1;
        } else {
            Toast.makeText(this, R.string.toast_onecode_fail, Toast.LENGTH_SHORT).show();
        }
    }

    //生成二维码
    private void createTwoCode(String data) {
        bitmap = null;
        Bitmap bmp = null;
        try {
            bmp = CodeUtils.CreateTwoDCode(new String(data.getBytes("utf-8"), "ISO-8859-1"));
            bmp = PicFromPrintUtils.compressPic(bmp);
        } catch (WriterException | UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        if (bmp != null) {
            code_img.setImageBitmap(bmp);
            bitmap = bmp;
        } else {
            Toast.makeText(this, R.string.toast_twocode_fail, Toast.LENGTH_SHORT).show();
        }
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        switch (event.getKeyCode()) {
            case 223:
                mScanConnect.scan();
                break;
            case 224:
                mScanConnect.scan();
                break;
            default:
                break;
        }
        return super.onKeyDown(keyCode, event);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        mScanConnect.stop();
        mPrintConnect.stop();
    }

}
