package com.obm.jniarr;

import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.text.TextUtils;
import android.view.View;
import android.view.WindowManager;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;

import com.obm.mylibrary.PrintConnect;
import com.obm.mylibrary.PrintUnits;

public class TextActivity extends AppCompatActivity {


    private EditText text;
    private CheckBox cb_line;
    private RadioButton rb_one, rb_two;
    private LinearLayout ll_line;
    private RadioButton rb_left, rb_center, rb_right;
    private TextView tv_con, tv_speed, tv_width;
    private SeekBar sb_con, sb_speed, sb_width;
    private int con = 0, speed = 7, width = 4, alignment = 0,  underline = 0;
    private PrintConnect mPrintConnect;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_text);
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_ADJUST_PAN);
        initView();
        setListener();
        mPrintConnect = MainActivity.mPrintConnect;
    }

    private void initView() {
        text = (EditText) findViewById(R.id.text);
        cb_line = (CheckBox) findViewById(R.id.cb_line);
        rb_one = (RadioButton) findViewById(R.id.rb_one);
        rb_two = (RadioButton) findViewById(R.id.rb_two);
        ll_line = (LinearLayout) findViewById(R.id.ll_line);
        rb_left = (RadioButton) findViewById(R.id.rb_left);
        rb_center = (RadioButton) findViewById(R.id.rb_center);
        rb_right = (RadioButton) findViewById(R.id.rb_right);
        tv_con = (TextView) findViewById(R.id.tv_con);
        sb_con = (SeekBar) findViewById(R.id.sb_con);
        tv_speed = (TextView) findViewById(R.id.tv_speed);
        sb_speed = (SeekBar) findViewById(R.id.sb_speed);
        tv_width = (TextView) findViewById(R.id.tv_width);
        sb_width = (SeekBar) findViewById(R.id.sb_width);
    }

    private void setListener() {
        sb_con.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                if (progress == 0) {
                    con = 1;
                } else if (progress == 1) {
                    con = 0;
                } else {
                    con = progress;
                }
                tv_con.setText(con + "");
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });
        sb_speed.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                switch (progress) {
                    case 0:
                        speed = 7;
                        break;
                    case 1:
                        speed = 6;
                        break;
                    case 2:
                        speed = 5;
                        break;
                    case 3:
                        speed = 4;
                        break;
                    case 4:
                        speed = 3;
                        break;
                    case 5:
                        speed = 2;
                        break;
                    case 6:
                        speed = 1;
                        break;
                    case 7:
                        speed = 0;
                        break;
                }
                tv_speed.setText(speed + "");
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });
        sb_width.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                width = progress + 1;
                tv_width.setText(width + "");
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });
        rb_left.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    alignment = 0;
                }
            }
        });
        rb_center.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    alignment = 1;
                }
            }
        });
        rb_right.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    alignment = 2;
                }
            }
        });

        cb_line.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    underline = 1;
                    cb_line.setText(R.string.choose_underline);
                    rb_one.setChecked(true);
                    ll_line.setVisibility(View.VISIBLE);
                } else {
                    underline = 0;
                    cb_line.setText(R.string.choose_no_underline);
                    ll_line.setVisibility(View.GONE);
                }
            }
        });
        rb_one.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                underline = 1;
            }
        });
        rb_two.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                underline = 2;
            }
        });
    }

    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.btn_character:
                text.setText("text");
                break;
            case R.id.btn_text:
                String data="text\rtext\rtext\rtext";
                text.setText(data);
                break;
            case R.id.btn_default:
                PrintUnits.setInitialize(mPrintConnect.os);
                break;
            case R.id.btn_print:
                submit();
                break;
        }
    }

    private void submit() {
        String textString = text.getText().toString().trim();
        if (TextUtils.isEmpty(textString)) {
            Toast.makeText(this, getString(R.string.toast_insert_text), Toast.LENGTH_SHORT).show();
            return;
        }
        PrintUnits.setSpeed(mPrintConnect.os, speed);
        PrintUnits.setConcentration(mPrintConnect.os, con);
        PrintUnits.setAlignment(mPrintConnect.os, alignment);
        PrintUnits.setLinewidth(mPrintConnect.os, width);
        PrintUnits.setUnderline(mPrintConnect.os, underline);
        mPrintConnect.send(textString);
        PrintUnits.setPagerLine(mPrintConnect.os, 3);
    }
}
